<template>
    <v-app>
        <v-app-bar fixed style="z-index: 10">
            <v-app-bar-nav-icon v-if="displayNavigationDrawer" @click="drawer = !drawer"/>
            <v-img id="logo"
                   @click="goHome"
                   :src="require('@/assets/images/ua_h_couleur_ecran.png')"
                   max-height="64px" max-width="128px"/>
            <v-spacer></v-spacer>
            <drop-down v-if="user" :title="isCurrentUserAllowed" :items="services"/>
        </v-app-bar>

        <v-navigation-drawer v-if="displayNavigationDrawer" v-model="drawer" app width="350" style="padding-top: 64px">
            <navigation-drawer/>
        </v-navigation-drawer>

        <v-main>
            <v-container fluid fill-height style="padding-top: 64px">
                <v-slide-y-transition mode="out-in">
                    <router-view></router-view>
                </v-slide-y-transition>

                <v-overlay :value="isLoading" width="20" class="text-center" opacity="0.9" z-index="42">
                    <v-progress-circular indeterminate size="150" width="10" color="#0bbbef"></v-progress-circular>
                    <h1 style="color: #0BBBEF">{{ $t("LNG_LOADER_INFO") }}</h1>
                </v-overlay>

            </v-container>
        </v-main>
    </v-app>
</template>

<script>
import { mapGetters } from "vuex";
import DropDown from "./components/DropDown.component";
import NavigationDrawer from '@/components/NavigationDrawer.component';
import Services from "@/services/api";
import { SET_USER } from "@/store/mutations.type";

export default {
    name: 'App',
    components: { NavigationDrawer, DropDown },
    data() {
        return {
            drawer: true,
            services: [
                {
                    title: this.$t('LNG_DROP_DOWN_FIELDS'),
                    link: "/",
                    icon: "mdi-wallet-travel"
                },
                {
                    title: this.$t('LNG_DROP_DOWN_TASKS'),
                    link: "/mytasks",
                    icon: "mdi-file-edit-outline "
                },
                {
                    title: this.$t('LNG_DROP_DOWN_LOGOUT'),
                    link: "/logout",
                    icon: "mdi-history"

                }
            ],
        }
    },
    computed: {
        ...mapGetters([
            'isLoading',
            'user',
            'authentication'
        ]),
        displayNavigationDrawer() {
            // add the name of the routes for those needing a navigation drawer
            return this.$route?.name?.includes(["LessonReader"]);
        },
        isCurrentUserAllowed() {
            return this.user.name + " " + this.user.first_name;
        },
    },
    watch: {
        authentication: async function (val) {
            await this.setUser(val);
        }
    },
    async mounted() {
        await this.setUser(this.authentication);
    },
    methods: {
        goHome() {
            if (this.$route.name !== "Fields" && this.$route.name !== "Login")
                this.$router.push({ name: "Fields" })
        },
        async setUser(val) {
            if (val) {
                Services.getUser(false).then(async res => {
                    switch (res.status) {
                        case 200:
                            this.$store.commit(SET_USER, await res.json());
                            break;
                        case 401:
                            await this.$router.push({ name: "Login" });
                            break;
                    }
                });
            }
        }
    }
};
</script>

<style scoped>
#logo:hover {
    cursor: pointer;
}
</style>
